!! @(#) eqbind.mod, 05.02.99, A.06.20
/* ----------------------------------------------------------------------

   eqbind.mod - Bindings for eq dlg

   Please Note:

   * This requires Dialog Manager Rev. A.03.01a or above.

   * Any structural change requires re-creation of the interface
     file. This can be done by executing

     idm +writeexport eqbind.if eqbind.mod

---------------------------------------------------------------------- */

module EqmBind

// import modules
import EqmRsrc "IDMLIB:eqrsrc.if";

// ======================================================================
// Callback Functions
// ----------------------------------------------------------------------
// HP ELOQUENCE needs this functions to keep track of current
// object state. If you don't care about compatibility, you may
// delete them.
//
// EqPushButtonCB  - If a pushbutton gets selected
// EqCheckBoxCB    - If a checkbox is (de-) activated
// EqRadioButtonCB - If a radiobutton is (de-) activated
// EqEditTextCB    - If a edittext looses focus
// ----------------------------------------------------------------------
// EqExitEventLoop - This will terminate DLG DO statement with
//                   given object and rule value.
//                   It will return upon next DLG DO statement.
// ----------------------------------------------------------------------

export function callback EqPushButtonCB() for select;
export function callback EqCheckBoxCB() for activate, deactivate;
export function callback EqRadioButtonCB() for activate;
export function callback EqEditTextCB() for deselect;
export function callback EqListBoxCB() for select, dbselect;

export function void EqExitEventLoop( object, integer );
export function boolean EqCallBack( string, object, integer );
export function void EqRestorePopup();

// ======================================================================
// Help Subsystem
// ----------------------------------------------------------------------
// EqHelpOnObject  - show object help
// EqHelpOnTag     - display arbitrary help
// EqHelpViewFile  - view text file in help window
// EqHelpManPage   - view man page in help window
//
// EqHelpPath      - help document path relative to HelpBaseURL (eloq.ini)
//
// Most function needs an object function argument to locate the
// help volume associated with dialog.
// The help volume may be defined using variable EqHelpPath.
// ----------------------------------------------------------------------

export config variable string EqHelpPath;

export function boolean EqHelpOnObject(object input);
export function boolean EqHelpOnTag(object input, string input);
export function boolean EqHelpViewFile(string input);
export function boolean EqHelpManPage(string input);

// ======================================================================
// Keyboard accelerators
// ----------------------------------------------------------------------
// The following accelerators are required by HP ELOQUENCE to
// map the keyboard behaviour.
// If you don't need them, you may delete them.
// ----------------------------------------------------------------------

export accelerator EqKbF1 F1;
export accelerator EqKbF2 F2;
export accelerator EqKbF3 F3;
export accelerator EqKbF4 F4;
export accelerator EqKbF5 F5;
export accelerator EqKbF6 F6;
export accelerator EqKbF7 F7;
export accelerator EqKbF8 F8;
export accelerator EqKbF9 F9;
export accelerator EqKbCR Return;

export accelerator EqKbSelect "space";

// ======================================================================
//    R U L E S
// ======================================================================

// Entry required by cvdlg

export rule boolean EqSaveDialog( string Fname ) {
   save( this, Fname );
   return(false);
}

// end of module --------------------------------------------------------
