!! @(#) eqdef.mod, 05.02.99, A.06.20
/* ----------------------------------------------------------------------

   eqdef.mod - defaults for eq dlg

   Please Note:

   * This requires Dialog Manager Rev. A.03.01a or above.

   * Any structural change requires re-creation of the interface
     file. This can be done by executing

     idm +writeexport eqdef.if eqdef.mod

---------------------------------------------------------------------- */

module EqmDef

// import modules
import EqmRsrc "IDMLIB:eqrsrc.if";
import EqmBind "IDMLIB:eqbind.if";


// ----------------------------------------------------------------------

export default canvas
{
  .visible true;
  .width 5;
  .height 5;
  .posraster true;
  .sizeraster true;
  .borderwidth 2;
}

// ----------------------------------------------------------------------

export default checkbox
{
  .visible true;
  .posraster true;
  .sizeraster true;
  .text "Checkbox";
  .function EqCheckBoxCB;
  .font NormalFont;
  integer EqRule := 0;
  integer EqRuleOverride := 0;
  .bgc ColWin;
  .fgc ColBlack;
}

// ----------------------------------------------------------------------

export default edittext
{
  .visible true;
  .font NormalFont;
  .posraster true;
  .sizeraster true;
//  .maxchars 0;
//  .height 1;
  .borderwidth 0;
  integer EqRule := 0;
  integer EqRuleOverride := 0;
  .function EqEditTextCB;
  .bgc ColInput;
  .fgc ColBlack;
}

// ----------------------------------------------------------------------

export default listbox
{
  .visible true;
  .font NormalFont;
  .width 40;
  .height 5;
  .posraster true;
  .sizeraster true;
  .firstchar 1;
  integer EqRule := 0;
  integer EqRuleOverride := 0;
  integer EqActiveline := 0;
  .function EqListBoxCB;
  .bgc ColWin;
  .fgc ColBlack;
  .borderwidth 1;
}

// ----------------------------------------------------------------------

export default image
{
  .visible true;
  .width 0;
  .height 0;
  .posraster true;
  .sizeraster true;
  .font NormalFont;
  integer EqRule := 0;
  integer EqRuleOverride := 1;
}

// ----------------------------------------------------------------------

export default menubox
{
  .visible true;
}

// ----------------------------------------------------------------------

export default menuitem
{
  .visible true;
}

// ----------------------------------------------------------------------

export default menusep
{
  .visible true;
}

// ----------------------------------------------------------------------

export default messagebox
{
  .button[1] button_ok;
  .button[2] button_cancel;
  .defbutton 1;
}

// ----------------------------------------------------------------------

export default poptext
{
  .visible true;
  .font NormalFont;
  .width 40;
  .posraster true;
  .sizeraster true;
  integer EqRule := 0;
  integer EqRuleOverride := 0;
  integer EqActiveline := 0;
  .function EqListBoxCB;
  .bgc ColWin;
  .fgc ColBlack;
}

// ----------------------------------------------------------------------

export default groupbox
{
  .visible true;
  .width 20;
  .height 5;
  .posraster true;
  .sizeraster true;
  .reffont BaseFont;
//  .borderwidth 1;
  .bgc ColWin;
  .fgc ColBlack;
}

// ----------------------------------------------------------------------

export default pushbutton
{
  .visible true;
//  .width 12;
  .posraster true;
  .sizeraster true;
  .function EqPushButtonCB;
  .font NormalFont;
  integer EqRule := 0;
  integer EqRuleOverride := 1;
  .bgc ColWin;
  .fgc ColBlack;
//  .style 0;
  .text "PushButton";
}

// ----------------------------------------------------------------------

export default radiobutton
{
  .visible true;
  .font NormalFont;
  .posraster true;
  .sizeraster true;
  .text "Radiobutton";
  .function EqRadioButtonCB;
  integer EqRule := 0;
  integer EqRuleOverride := 0;
  .bgc ColWin;
  .fgc ColBlack;
}

// ----------------------------------------------------------------------

export default rectangle
{
  .visible true;
  .width 5;
  .height 5;
  .posraster true;
  .sizeraster true;
  .borderwidth 1;
  .filled true;
}

// ----------------------------------------------------------------------

export default scrollbar
{
  .visible true;
  .font NormalFont;
  .width 0;
  .height 5;
  .posraster true;
  .sizeraster true;
  .linemotion 1;
  .pagemotion 1;
}

// ----------------------------------------------------------------------

export default statictext
{
  .visible true;
  .sensitive false;
  .posraster true;
  .sizeraster true;
  .text "Statictext";
  .font NormalFont;
  .bgc ColWin;
  .fgc ColBlack;
}

// ----------------------------------------------------------------------

export default tablefield
{
  .visible true;
  .font NormalFont;
  .width 20;
  .height 5;
  .posraster true;
  .sizeraster true;
  .editpos true;
  .colcount 5;
  .rowcount 5;
  .colfirst 1;
  .rowfirst 1;
  .colwidth[0] 20;
  .rowheight[0] 1;
  .reffont BaseFont;
}

// ----------------------------------------------------------------------

export default window
{
//  .visible true;
  .visible false;
  .font NormalFont;
  .width 60;
  .height 10;
  .posraster false;
  .sizeraster true;
//  .reffont FontNormal;
  .reffont BaseFont;
  .closeable false;
  .dialogbox true;
  .moveable true;
  .sizeable false;
  .iconic false;
  .iconifyable true;
  .title "Window";
// This is necessary to handle eloquence style like accelerators.
// [1] = CR, [2]..[9] = F1..8, [10] = reserved (F9)
   integer EqKbRule[10];
  .bgc ColWin;
  .fgc ColBlack;
// Windoze CTL3D
// .options[opt_no_clipping] true;
// .options[opt_use_3d] true;
}

// ======================================================================
//
//    R U L E S
//
// ======================================================================

// keyboard events on window

on WINDOW key EqKbCR
{
   if (typeof(this.window.EqKbRule[1]) = integer) then
      if this.window.EqKbRule[1] then
         EqExitEventLoop(this, this.window.EqKbRule[1]);
      endif
   endif
}
on WINDOW key EqKbF1
{
   if this.window.EqKbRule[2] then
      EqExitEventLoop(this, this.window.EqKbRule[2]);
   endif
}
on WINDOW key EqKbF2
{
   if this.window.EqKbRule[3] then
      EqExitEventLoop(this, this.window.EqKbRule[3]);
   endif
}
on WINDOW key EqKbF3
{
   if this.window.EqKbRule[4] then
      EqExitEventLoop(this, this.window.EqKbRule[4]);
   endif
}
on WINDOW key EqKbF4
{
   if this.window.EqKbRule[5] then
      EqExitEventLoop(this, this.window.EqKbRule[5]);
   endif
}
on WINDOW key EqKbF5
{
   if this.window.EqKbRule[6] then
      EqExitEventLoop(this, this.window.EqKbRule[6]);
   endif
}
on WINDOW key EqKbF6
{
   if this.window.EqKbRule[7] then
      EqExitEventLoop(this, this.window.EqKbRule[7]);
   endif
}
on WINDOW key EqKbF7
{
   if this.window.EqKbRule[8] then
      EqExitEventLoop(this, this.window.EqKbRule[8]);
   endif
}
on WINDOW key EqKbF8
{
   if this.window.EqKbRule[9] then
      EqExitEventLoop(this, this.window.EqKbRule[9]);
   endif
}
on WINDOW help
{
   EqHelpOnObject(this);
}

// image
// NOTE: CR on image has some kind of precedence over CR rule

on IMAGE select, key EqKbCR {
   if( this.EqRule ) then
      EqExitEventLoop( this, this.EqRule );
   endif
}

// pushbutton
// NOTE: CR on pushbutton has some kind of precedence over CR rule

on PUSHBUTTON select, key EqKbCR {
   if( this.EqRule ) then
      EqExitEventLoop( this, this.EqRule );
   endif
}

// checkbox: state changed

on CHECKBOX activate, deactivate {
   if( this.EqRule ) then
      EqExitEventLoop( this, this.EqRule );
   endif
}

// radiobutton: state changed

on RADIOBUTTON activate {
   if( this.EqRule ) then
      EqExitEventLoop( this, this.EqRule );
   endif
}

// listbox
// This rule allows to browse listbox content by keybd even on a graphical ui

on LISTBOX dbselect {
   this.EqActiveline := this.activeitem;
   if( this.EqRule ) then
      EqExitEventLoop( this, this.EqRule );
   endif
}

on LISTBOX key EqKbSelect {
   this.EqActiveline := this.activeitem;
   if( this.EqRule ) then
      EqExitEventLoop( this, this.EqRule );
   endif
}

// poptext: selected line has changed

on POPTEXT select {
   this.EqActiveline := this.activeitem;
   if( this.EqRule ) then
      EqExitEventLoop( this, this.EqRule );
   endif
}

// edittext: deselected

on EDITTEXT deselect {
   variable integer RuleOverride := 0;
   if (this.window.focus <> null) then
      if( typeof( this.window.focus.EqRuleOverride ) = integer ) then
         RuleOverride := this.window.focus.EqRuleOverride;
      endif;
   endif;
   if( RuleOverride = 0 ) then
      if( this.EqRule ) then
         EqExitEventLoop( this, this.EqRule );
      endif
   endif
}

// edittext: deselected by CR

on EDITTEXT deselect_enter {
   if (typeof(this.window.EqKbRule[1]) = integer) then
      if(this.window.EqKbRule[1]) then
         EqExitEventLoop( this, this.window.EqKbRule[1] );
      endif
   endif
}

// end of module --------------------------------------------------------
